//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "OptionsForm.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TOptions *Options;
//---------------------------------------------------------------------------
__fastcall TOptions::TOptions(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------


void __fastcall TOptions::ItemBrowseButtonClick(TObject *Sender)
{
        if(OpenPictureDialog1->Execute())
        {
            BitmapEdit->Text=OpenPictureDialog1->FileName;
        }
}
//---------------------------------------------------------------------------

void __fastcall TOptions::ObjBrowseButtonClick(TObject *Sender)
{
        if(OpenDialog2->Execute())
        {
            ObjectEdit->Text=OpenDialog2->FileName;
        }

}
//---------------------------------------------------------------------------


void __fastcall TOptions::HeightCheckBoxClick(TObject *Sender)
{
    HeightLimitEdit->Enabled=HeightCheckBox->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TOptions::WidhtCheckBoxClick(TObject *Sender)
{
    WidhtLimitEdit->Enabled=WidhtCheckBox->Checked;

}
//---------------------------------------------------------------------------

void __fastcall TOptions::BitBtn1Click(TObject *Sender)
{
    if (BitmapEdit->Text.Length() > 127) {
        ShowMessage("      127 ,  .             .");
        return;
    }
    if (ObjectEdit->Text.Length() > 127) {
        ShowMessage("      127 ,  .             .");
        return;
    }

    ItemHgt     =   ItemHgtEdit->Value;
    ItemLen     =   ItemLenEdit->Value;
    HorisItems  =   HorisItemsEdit->Value;

    if( MainForm->ItemFile != BitmapEdit->Text ) {
        MainForm->ItemBmp->LoadFromFile( BitmapEdit->Text );
        MainForm->ItemFile=BitmapEdit->Text;
    }

    if( ObjectFile != ObjectEdit->Text ) {
        //   
        if(bObjectModified) { //   
        int result = Application->MessageBox(
            "The object's data was modified. Save changes?",
            "Level Editor", MB_YESNOCANCEL | MB_ICONWARNING);
        if(result == IDYES)
        {
            if(ObjectFile== "" ) {
                //     
                SaveObjectAsDialog->Title="Save Objects data";

                if(SaveObjectAsDialog->Execute())
                    ObjectFile=SaveObjectAsDialog->FileName;
                else
                    ObjectFile="objects.lbj";
            }
            SaveObjectFile(ObjectFile);
        }

    }

        LoadObjectFile( ObjectEdit->Text );
        ObjectFile=ObjectEdit->Text;
    }

    MainForm->LH.bFixedHgt  =   HeightCheckBox->Checked;
    MainForm->LH.bFixedLen  =   WidhtCheckBox->Checked;
    MainForm->LH.LevHgt     =   HeightLimitEdit->Value;
    MainForm->LH.LevLen     =   WidhtLimitEdit->Value;
    MainForm->LH.bFixedLen  =   WidhtLimitEdit->Enabled;
    MainForm->LH.bFixedHgt  =   HeightLimitEdit->Enabled;

    Close();
}
//---------------------------------------------------------------------------


void __fastcall TOptions::FormShow(TObject *Sender)
{
    ItemHgtEdit->Value=ItemHgt;
    ItemLenEdit->Value=ItemLen;
    HorisItemsEdit->Value=HorisItems;
    BitmapEdit->Text=MainForm->ItemFile;
    ObjectEdit->Text=ObjectFile;
    HeightCheckBox->Checked=MainForm->LH.bFixedHgt;
    WidhtCheckBox->Checked=MainForm->LH.bFixedLen;
    HeightLimitEdit->Value=MainForm->LH.LevHgt;
    WidhtLimitEdit->Value=MainForm->LH.LevLen;

    WidhtLimitEdit->Enabled=MainForm->LH.bFixedLen;
    HeightLimitEdit->Enabled=MainForm->LH.bFixedHgt;


}
//---------------------------------------------------------------------------





