//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Edit.h"
#include "defines.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "cspin"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TEditObjectForm *EditObjectForm;
//---------------------------------------------------------------------------
__fastcall TEditObjectForm::TEditObjectForm(TComponent* Owner)
    : TForm(Owner)
{
    Cur_index=-1;
}
//---------------------------------------------------------------------------
void __fastcall TEditObjectForm::BitBtn1Click(TObject *Sender)
{
    //    
unsigned int m;
OBJECTFILEOBJECT* newobject;    //  

for(m=0; m<ObjFileList->Count; m++) //    ObjFileList   type
    if( (String)(((OBJECTFILEOBJECT*)ObjFileList->Items[m])->objname) == NameEdit->Text)
        {
        delete (OBJECTFILEOBJECT*)ObjFileList->Items[m];
        ObjFileList->Delete(m);
        }

    //      
    newobject=new OBJECTFILEOBJECT;

    //      TMainForm.ObjFileList
    newobject->type  =  TypeEdit->Value;
    newobject->param =  ParamEdit->Value;

    if( BmpEdit->Text !="" && CheckBox->Checked==true )
    {
    ObjBmp->LoadFromFile( BmpEdit->Text );
    newobject->len   =  ObjBmp->Width;
    newobject->hgt   =  ObjBmp->Height;
    }
    else  //    ,   bmp
    { //   ,
    newobject->len   =  WidthEdit->Value;
    newobject->hgt   =  HeightEdit->Value;
    }

    //       ,  16  .
    if( newobject->len<1 ) newobject->len=16;
    if( newobject->hgt<1 ) newobject->hgt=16;

    memcpy(newobject->objname,NameEdit->Text.c_str(),31);
    memcpy(newobject->bitmap, BmpEdit->Text.c_str() ,31 );

    ObjFileList->Add(newobject);
    bObjectModified=true;
}
//---------------------------------------------------------------------------


void __fastcall TEditObjectForm::BmpEditChange(TObject *Sender)
{
    if( Text != "" )CheckBox->Enabled=true;
        else CheckBox->Enabled=false;

}
//---------------------------------------------------------------------------


void __fastcall TEditObjectForm::FormShow(TObject *Sender)
{
    //  TComboBox  ObjectBox
    NameEdit->Clear();
    //  
    for(int n=0; n< ObjFileList->Count; n++)  {
        NameEdit->Items->AddObject(
            ((OBJECTFILEOBJECT*)ObjFileList->Items[n] )->objname,
            (System::TObject*)ObjFileList->Items[n] );
    }
    NameEdit->ItemIndex=Cur_index;

}
//---------------------------------------------------------------------------
void __fastcall TEditObjectForm::NameEditChange(TObject *Sender)
{
    OBJECTFILEOBJECT* newobject;

    Cur_index = NameEdit->ItemIndex;
    if( Cur_index == -1 ) return;

    newobject = ((OBJECTFILEOBJECT*)ObjFileList->Items[Cur_index]);

    //       
    TypeEdit->Value  =  newobject->type;
    ParamEdit->Value  = newobject->param;
    BmpEdit->Text = newobject->bitmap;
    CheckBox->Checked=(BmpEdit->Text != "")? true:false;
    WidthEdit->Value =newobject->len;
    HeightEdit->Value=newobject->hgt;
}
//---------------------------------------------------------------------------

