//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TestForm.h"
#include "Main.h"
#include <inifiles.hpp>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTestLevelForm *TestLevelForm;

extern String LevelFileName;    //    


//---------------------------------------------------------------------------
__fastcall TTestLevelForm::TTestLevelForm(TComponent* Owner)
    : TForm(Owner)
{
    TIniFile *ini;

    ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

    ExeEdit->Text =  ini->ReadString( "TestLevelForm", "GameExe","" );

    delete ini;
}
//---------------------------------------------------------------------------
void __fastcall TTestLevelForm::Button1Click(TObject *Sender)
{
    if(OpenTestDialog->Execute())
    {
        ExeEdit->Text=OpenTestDialog->FileName;
    }
}
//---------------------------------------------------------------------------
void __fastcall TTestLevelForm::okbuttonClick(TObject *Sender)
{
    HINSTANCE hinst;

    ExeEdit->Items->Add(ExeEdit->Text);

    //  ,  
    //     

    hinst=ShellExecute(
        Handle,
        "open",    //LPCTSTR lpOperation,
        ExeEdit->Text.c_str(),//LPCTSTR lpFile,
        ParamsEdit->Text.c_str(),//LPCTSTR lpParameters,
        String(ExtractFileDir(ExeEdit->Text)).c_str(),//LPCTSTR lpDirectory,
        SW_SHOWDEFAULT//INT nShowCmd
    );

    if( (int)hinst<32 )
        MessageBox(Handle,"  ","",MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TTestLevelForm::FormShow(TObject *Sender)
{
    ParamsEdit->Text = LevelFileName;
}
//---------------------------------------------------------------------------


void __fastcall TTestLevelForm::FormDestroy(TObject *Sender)
{
//   
  TIniFile *ini;
   ini = new TIniFile(ChangeFileExt( Application->ExeName, ".INI" ) );
   ini->WriteString( "TestLevelForm", "GameExe",TestLevelForm->ExeEdit->Text );
   delete ini;
}
//---------------------------------------------------------------------------

